# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.20-1.2320.fc5}

%define kmod_name em8300
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%ifarch i586 ppc
%define smp smp
%endif
%ifarch i686
%define smp smp smp-debug
%endif
%ifarch i686 x86_64
%define xen xen xen0
%define kdump kdump
%define dbg debug
%endif
%{!?kvariants: %define kvariants "" %{?smp} %{?xen} %{?kdump} %{?dbg}}


Name:           %{kmod_name}-kmod
Summary:        Kernel modules for DXR3/Hollywood Plus MPEG decoder cards
Version:        0.16.1
Release:        0.%(echo %{kverrel} | tr - _).2

Group:          System Environment/Kernel
License:        GPL
URL:            http://dxr3.sourceforge.net/
Source0:        http://downloads.sourceforge.net/dxr3/%{kmod_name}-nofirmware-%{version}.tar.gz
Patch0:         http://cachalot.mine.nu/src/dxr3/em8300-adv7170-wss.patch
Patch1:         http://cachalot.mine.nu/src/dxr3/em8300-oss-default.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  i586 i686 x86_64 ppc

%description
%{summary}.

%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c
cd %{kmod_name}-%{version}
%patch0 -p0
%patch1 -p0
cd ..
for kvariant in %{kvariants} ; do
    cp -a %{kmod_name}-%{version} _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants} ; do
    kv=%{kverrel}$kvariant
    ks=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    make %{?_smp_mflags} -C _kmod_build_$kvariant/modules \
        V=1 KERNVER=$kv KERNEL_LOCATION=$ks
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants} ; do
    kv=%{kverrel}$kvariant
    ks=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    make -C _kmod_build_$kvariant/modules install DESTDIR=$RPM_BUILD_ROOT \
        KERNVER=$kv KERNEL_LOCATION=$ks INSTALL_MOD_DIR=extra/%{kmod_name}
done
chmod +x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*.ko


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Thu Jun 21 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.20-1.2320.fc5.

* Tue Jun 12 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.20-1.2319.fc5.

* Tue May  1 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.20-1.2316.fc5.

* Fri Apr 13 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.20-1.2312.fc5.

* Fri Mar 23 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.1-0.2
- Re-enable xen, build for kernel 2.6.20-1.2307.fc5.

* Thu Mar 15 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.1-0.1
- 0.16.1, kmodtool 0.10.13.
- Build for kernel 2.6.20-1.2300.fc5 and adjust variants for it
  (add smp-debug for i686, debug for i686 and x86_64, disable xen).

* Tue Mar  6 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.19-1.2288.2.4.fc5.

* Fri Mar  2 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.19-1.2288.2.1.fc5.

* Wed Feb 14 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.19-1.2288.fc5.

* Mon Dec 18 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-1
- 0.16.0, build for kernel 2.6.18-1.2257.fc5.
- Let rpmbuild strip modules.
- Build i586 SMP modules too.

* Sat Nov 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-0.0.rc2
- 0.16.0-rc2, build for kernel 2.6.18-1.2239.fc5.

* Mon Oct 16 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-0.0.rc1
- Build for kernel 2.6.18-1.2200.fc5.
- Don't use <linux/config.h>.

* Mon Oct  2 2006 Ville Skyttä <ville.skytta at iki.fi>
- 0.16.0-rc1, kernel 2.6.17 patch applied upstream.
- Patch to default to OSS for backwards compatibility.
- Drop early FC5 hacks.

* Fri Sep 15 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-8
- Rebuild for kernel 2.6.17_1.2187_FC5.
- Build for the xen variant too.

* Thu Aug 10 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-7
- Rebuild for kernel 2.6.17_1.2174_FC5.
- Update kmodtool to 0.10.11.

* Tue Jul 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-6
- Enable PPC SMP builds (#189400).
- Use firmwareless tarball (#189400).
- Untabify specfile (#189400).

* Mon Jun 26 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-5
- Apply upstream patch to fix build with kernel 2.6.17, rediff WSS patch.

* Sun Jun 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-4
- Invoke kmodtool with bash instead of sh.

* Sun May 14 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-3
- Require version >= of em8300-kmod-common.
- Provide em8300-kmod instead of kmod-em8300 to fix upgrade woes (#970).

* Thu Apr 27 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-2
- Provide "kernel-modules" instead of "kernel-module" to match yum's config.

* Mon Apr 10 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-1
- 0.15.3.

* Sun Mar 26 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-0.1.rc1
- 0.15.3-rc1.

* Sat Mar 25 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-6.cvs20060325
- CVS snapshot from today, I2C patches no longer needed, should fix #839.
- Allow passing --define kversion and --define kvariants to the build again.
- Update kmodtool to 0.10.6.

* Sat Mar 18 2006 <fedora[AT]leemhuis.info> - 0.15.2-5
- xenU does not build and was probably a bad idea idea in any case

* Sat Mar 18 2006 <fedora[AT]leemhuis.info> - 0.15.2-4
- drop 0.lvn
- hardcode kernel and variants
- add ExclusiveArch until we have something better

* Sun Jan 29 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.4
- Adapt to FE kernel module packaging conventions.
- Add upstream patch to fix build with 2.6.16-rc1+ kernels.

* Sat Jan 21 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.3
- Don't run autoreconf in modules-only builds (#736).

* Fri Jan 13 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.2
- Split GUI utilities into -utils subpackage, build them with GTK2.
- Drop no longer needed -fPIC tweak on x86_64.
- Fix Group tag of main package.

* Thu Nov 24 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.1
- 0.15.2.
- Make the actual microcode to load a symlink; additional local microcodes
  can now be installed in /lib/firmware, and /lib/firmware/em8300.bin
  symlinked to the one to actually use.

* Sat Nov 19 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.0.1.rc2
- 0.15.2-rc2, most desktop entry fixups applied upstream.
- Add icon for DXR3view menu entry.

* Sat Nov  5 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.0.1.rc1
- 0.15.2-rc1, includes microcode autoload capabilities.
- Include icon for dhc, remove invalid desktop entry categories.
- Update README-modprobe.conf.

* Tue Sep  6 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.1-0.lvn.1
- 0.15.1.

* Wed Aug 31 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.1-0.lvn.0.1.rc1
- 0.15.1-rc1, drop udev patch.

* Mon Jul 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.5
- Drop libdxr3, nothing uses it and it'll be removed in next upstream release.

* Fri Jul  8 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.4
- Install modules into extra/em8300.

* Sat Jun 18 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.3
- Use udev rules.d snippet for device permissions.

* Sun Jun 12 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.2
- Add "--with 2612" rpmbuild option to enable building with 2.6.12-pre
  kernels that report themselves as 2.6.11, such as early FC4 ones.

* Wed Jun  1 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.1
- 0.15.0.

* Sun May 29 2005 Thorsten Leemhuis <fedora at leemhuis.info> - 0.15.0-0.lvn.0.15.rc4
- Build userspace with -fPIC on x86_64 to fix build error

* Tue May 24 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.14.rc4
- 0.15.0rc4, memset patch applied upstream.

* Fri May 13 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.13.rc3
- Improve optional rpmbuild options:
  --without modules: do not build the kernel modules
  --without userland: do not build the userland stuff

* Fri Apr 29 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.rc3
- 0.15.0.rc3.

* Sun Apr 10 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.rc2
- 0.15.0.rc2.
- Drop unused Provides: kernel-module.
- Move video group creation from main to kernel module package(s).

* Sat Apr  2 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.cvs20050331
- Add FC4 kernel-devel and new kernel-module-devel compatibility.

* Thu Mar 31 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050331
- Update to upstream CVS HEAD as of now, many patches applied upstream.

* Sat Mar 26 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050326
- Update to upstream CVS HEAD as of now.
- Revert microcode location to upstream default (/usr/share/misc/em8300.uc).

* Tue Mar  8 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050308
- Update to upstream CVS HEAD as of now.

* Sun Feb 27 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.10.cvs20050227
- Update tarball naming and modprobe.conf README, no upstream changes.

* Mon Feb  7 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.10.cvs20041117
- Use my pre-rolled/patched tarball.
- Remove unnecessary Epochs.

* Tue Jan 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.9.cvs20041117
- URLize patches and extra sources.

* Fri Jan  7 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.8.cvs20041117
- Remove "manual" device node creation, let udev handle all of it.
- Add console.perms README.

* Mon Dec  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.7.cvs20041117
- Apply ADV7170 WSS patch from Seppo Ingalsuo.
- Include upstream ALSA patch, but don't apply it just yet.
- Fix em8300setup usage message.
- Get rid of acconfig.h to appease newer autotools.
- Make "--with(out) kmod" conditional sections smaller in the specfile.

* Sun Dec  5 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.6.cvs20041117
- Create the video group in the correct place.

* Sun Nov 28 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.5.cvs20041117
- Adjust setup for udev.
- Create/use the video group.
- Avoid creating /usr/include/linux twice during build.

* Wed Nov 17 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20041117
- Update to 20041117, most patches applied upstream.

* Wed Nov  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20041101
- Update to 20041101 + upstream patches.

* Sat Oct  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20040907
- Fix module directory permissions.

* Mon Sep 13 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.3.cvs20040907
- Install modules into /lib/modules/$uname/updates/em8300.
- Add URL to tarball.

* Sat Sep 11 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.2.cvs20040907
- Reset mode of installed modules to 644.

* Tue Sep  7 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040907
- Update to 0.15.0.cvs20040907.
- Disable dependency tracking to speed up the build.

* Sun Aug 29 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040827
- Update to 0.15.0.cvs20040827.

* Fri Jul 30 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040730
- Reorganize packaging, introduce libdxr3* as real subpackages.
- Add "--without kmod" rpmbuild option for skipping the kernel module build
  and "--with kmod" for building only the kernel modules.
- s/fdr/lvn/ due to non open source microcode.

* Sat Jul  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.fdr.0.1.cvs20040702
- Update to 0.15.0.cvs20040702.

* Wed Mar 17 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.14.0-0.fdr.1
- Update to 0.14.0.

* Fri Feb 20 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.3.cvs20040220
- Update to CVS 20040220.

* Mon Feb  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.3.cvs20040107
- Update to kmodhelper 0.9.8.

* Sat Jan 31 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.2.cvs20040107
- Drop release from the dependency between the kernel module and main package.
- Update kmodhelper to 0.9.7.
- Use MAKEDEV for creating the device nodes.
- Spec file cleanups.

* Tue Jan  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.1.cvs20040107
- First build.
